// *********************************************************
//
// sk.hh          : Steel Knight Include File
// author         : Fabio Silva
//
// $Id: sk.hh,v 1.1 2001/11/21 19:51:30 fabio Exp $
//
// *********************************************************

#ifndef sk_hh
#define sk_hh

#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include "dr.hh"

// BAE Includes
#include "ProcStruct.h"
#include "RepUtil.h"
#include "RepTypeSafe.h"
#include "SubscriptionManager.h"

// Fantastic Data Includes
#include "libfdb.h"

extern NRSimpleAttributeFactory<char *> TaskAttr;
extern NRSimpleAttributeFactory<void *> CpaAttr;

class MyReceive : public NR::Callback {
public:
  void recv(NRAttrVec *data, NR::handle my_handle);
};

#define TASK_KEY          5000
#define CPA_KEY           5001

class CpaEvent {
public:
  int node_id;
  CHANNEL channel_id;
  SENSORID sensor_id;
  int direction;
  float confidence;
  double cpa_time;
};

class SensorApp {
public:
  SensorApp(int _node_id, u_int16_t port);
  void run();
  void recv(NRAttrVec *data, NR::handle my_handle);
  void sensorCallback(REP_EVENT ev);

private:
#ifdef DEBUG
  FILE *outfile;
#endif
  NR *dr;
  MyReceive *mr;
  int node_id;
  int tasked;
  int events_counter;

  // Handles
  handle publishHandle;
  handle subscribeHandle;

  // Methods
  handle setupPublication();
  handle setupSubscription();
};

class GatewayApp {
public:
  GatewayApp(int _node_id, u_int16_t port);
  void run();
  void recv(NRAttrVec *data, handle h);

  MyReceive *mr;

private:
  // Class variables
#ifdef DEBUG
  FILE *outfile;
#endif
  NR *dr;
  int node_id;
  int sensor_counter;

  // Handles
  handle subscribeSensorHandle;

  // Methods
  handle setupSensorInterest();

  void ProcessSensorInfo(NRAttrVec *data);
};

#endif
