############################################################
#
# Makefile configuration file
#
############################################################

MAKE	 = 	gmake

#
#
# Step 1: Select the target platform by uncommenting
#	  the appropriate lines below
#


# For the i386 platform, use the following lines:
#C       =	gcc
#CC	=	g++
#AR	=	ar
#STRIP   =	strip

# For the WinsNG 2.0 SH4 platform, use the following:
C	 =	sh4-linux-gcc
CC 	 =	sh4-linux-g++
AR	 = 	sh4-linux-ar
STRIP   =      sh4-linux-strip

# For the Ipaq ARM platform, use the following:
#AR      =      arm-linux-ar
#AS	 =	arm-linux-as
#CC	 =	arm-linux-gcc
#CXX	 =	arm-linux-c++
#GXX	 =	arm-linux-g++
#LD	 =	arm-linux-ld
#NM	 =	arm-linux-nm
#RANLIB	 =	arm-linux-ranlib
#STRIP	 =	arm-linux-strip
#OTHER_LIBS = -L/usr/local/arm/2.95.3/lib/gcc-lib/arm-linux/2.95.3 -lstdc++

#
#
# Step 2: Select the corresponding hardware from one
#         of the options below
#


# Use the following lines with the RPC radios
#AC_DEFS  = 	 -DSTATS -DUSE_RPC -DUSE_BROADCAST_MAC -DUDP -DUSE_THREADS
#HWOBJECTS =	 main/drivers/RPCio.o main/drivers/UDPlocal.o

# Use the following lines for wired (Ethernet) testing
#AC_DEFS  = 	 -DSTATS -DUSE_BROADCAST_MAC -DUDP -DWIRED -DUSE_THREADS
#HWOBJECTS =	 main/drivers/UDPwired.o main/drivers/UDPlocal.o

# Use the following lines with the MoteNic
#AC_DEFS  =      -DSTATS -DUSE_BROADCAST_MAC -DUDP -DUSE_MOTE_NIC -DUSE_THREADS
#HWOBJECTS =	 main/drivers/MOTEio.o main/drivers/UDPlocal.o

# Add the following two lines to enable BBN logger support
#BBN_ROOT    =	/home/fabio/release/29p/sensit2/sensit2/bbn
#LOGGER_DEFS =	-DBBN_LOGGER -I$(BBN_ROOT)/logger \
#		-I$(BBN_ROOT)/other_libs/libsocketcpp-1.0.6/src \
#		-I$(BBN_ROOT)/utils -I$(BBN_ROOT)/other_libs/objectthread
#
#OTHER_LIBS = 	-L$(BBN_ROOT)/other_libs/objectthread -L$(BBN_ROOT)/logger \
#		-L$(BBN_ROOT)/other_libs/libsocketcpp-1.0.6/src/.libs \
#		-lLogger -lsocketcpp -lObjectThread
#

# Use the following lines with the WINSng2.0 node
AC_DEFS = 	 -DSTATS -DUDP -DUSE_WINSNG2 -DUSE_THREADS $(LOGGER_DEFS)
HWOBJECTS =	 main/drivers/WINSng2.o main/drivers/UDPlocal.o
