//
// UDPlocal.hh   : UDP Local Support Include File
// Authors       : Chalermek Intanagonwiwat and Fabio Silva
//
// Copyright (C) 2000-2001 by the Unversity of Southern California
// $Id: UDPlocal.hh,v 1.4 2002/02/16 00:27:37 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef udplocal_hh
#define udplocal_hh

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 

#include "iodev.hh"

#define LOCALHOST "127.0.0.1"
#define MAX_UDP_MESSAGE_SIZE 1500

class LocalAgentEntry {
public:
  u_int16_t agent_port;
  int fd;
  struct sockaddr_in skt_addr_inet;
};

typedef list<LocalAgentEntry *> LocalAgentsList;

class UDPLocal : public DiffusionIO {
public:
  UDPLocal(u_int16_t *port);
  DiffPacket recvPacket(int fd);
  void sendPacket(DiffPacket pkt, int len, int dst);

protected:
  void addLocalAgent(LocalAgentEntry *agent, u_int16_t port);

  LocalAgentsList local_agents;
};

#endif // udplocal_hh
