//
// UDPwired.hh   : UDP Wired Support Include File
// Authors       : Chalermek Intanagonwiwat and Fabio Silva
//
// Copyright (C) 2000-2001 by the Unversity of Southern California
// $Id: UDPwired.hh,v 1.4 2002/02/16 00:27:37 fabio Exp $
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef udpwired_hh
#define udpwired_hh

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <time.h>

#include "iodev.hh"

#define RELIABLE_LINK 100
#define MAX_UDP_MESSAGE_SIZE 1500

class TopologyEntry {
public:
  TopologyEntry(){};
  ~TopologyEntry(){};

  int fd;
  struct sockaddr_in skt_addr_inet;
  int quality;
};

typedef list<TopologyEntry *> TopologyList;

class UDPWired : public DiffusionIO {
public:
  UDPWired(char *config_file);
  DiffPacket recvPacket(int fd)
  {
    return NULL;
  };
  void sendPacket(DiffPacket pkt, int len, int dst);

protected:
  TopologyList neighbors_list;
};

#endif // udpwired_hh
